
/******************************************************************************

    Copyright (c) 1998-2000 CoWare, Inc.    ALL RIGHTS RESERVED
The following code is derived, directly or indirectly, from the SystemC
source code released by Synopsys, Inc Copyright (c) 1996-2001, Synopsys,
Inc., CoWare, Inc., Frontier Design, Inc. and others. All Rights reserved.
The contents of this file are subject to the restrictions and limitations
set forth in the SystemC Open Source License Version 2.0 (the "License");
You may not use this file except in compliance with such restrictions and
limitations. You may obtain instructions on how to receive a copy of the
License at http://www.systemc.org/.  Software distributed by Contributors
under the License is distributed on an "AS IS" basis, WITHOUT WARRANTY OF
ANY KIND, either express or implied. See the License for the specific
language governing rights and limitations under the License."

******************************************************************************/

/****************************************************************
    sc_link_mp.cpp - base class for refinable channels
	Implements connection between multiple masters and slaves

    Authors
	: Harish Sarin, CoWare Inc. (harish@coware.com)
	: Cesar Quiroz, CoWare Inc. (cesar@coware.com)
	: Vijay Kumar,  CoWare Inc. (vijay@coware.com)

    MODIFICATION LOG 
    Modifier Name & Affiliation:
    Description of Modification:

****************************************************************/

#ifndef SC_LINK_MP_H
#define SC_LINK_MP_H


#include "sc_link_mp_b.h"
#include "sc_logic_vector.h"

template <class T=int>
class sc_link_mp : public sc_link_mp_b {
 public:
	sc_link_mp(const char *NAME=0)
		: sc_object(NAME), sc_link_mp_b(NAME) {
	}
	virtual BIND_STATUS bind(sc_port_protocol& p) {
		if(signals==0)
			signals=p.make_link_protocol(name());
		return p.bind(signals);
	}
};

#endif
